workflow:
  name: Build 'telegram-desktop-userfonts' pacman package
  rules:
    - if: $CI_PIPELINE_SOURCE == "schedule"
    - if: $CI_PIPELINE_SOURCE == "web"
    - if: $CI_PIPELINE_TRIGGERED
    - when: never

variables:
  AUR_SOURCE_REPO: "https://aur.archlinux.org/telegram-desktop-userfonts.git"
  GIT_CLONE_DEPTH: "3"

stages:
  - check
  - build

check-source-changes:
  stage: check
  image: bitnami/git:latest
  variables:
    GIT_COMMIT_FRESHNESS: "1 day"
  rules:
    - if: $CI_PIPELINE_SOURCE == "schedule"
    - if: $CI_PIPELINE_TRIGGERED && $CI_TRIGGER == "check-changes"
    - if: $CI_PIPELINE_SOURCE == "web" && $CI_TRIGGER == "check-changes"
  script:
    - git clone --depth ${GIT_CLONE_DEPTH} "${AUR_SOURCE_REPO}" source
    - git -C source log --since="${GIT_COMMIT_FRESHNESS}" --oneline | tee commit.log
    - |
      if [ -s commit.log ] ; then
        curl --fail -X POST --form "token=${CI_TRIGGER_TOKEN}" --form "ref=main" --form "variables[CI_TRIGGER]=source-changed" "${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/trigger/pipeline"
      else
        echo "No source changes detected"
      fi
  artifacts:
    paths:
      - commit.log

makepkg:
  stage: build
  image: archlinux/archlinux:base-devel
  variables:
    WORK_DIR: /home/nobody/build
  rules:
    - if: $CI_PIPELINE_TRIGGERED && $CI_TRIGGER == "source-changed"
    - if: $CI_PIPELINE_SOURCE == "web" && $CI_TRIGGER == "makepkg"
  before_script:
    # Install most recent keyring
    - pacman-key --init
    - pacman -Sy --noconfirm archlinux-keyring
    # Update build environment
    - pacman -Su --noconfirm
    # Install various vcs packages needed to fetch sources of PKGBUILDs
    - pacman -S --noconfirm sudo git
    # The repository build script is run by user 'nobody'. The build scripts needs
    # to install dependencies using pacman. This requires root permissions.
    # (Note: the build script itself can't be run as root, as makepkg would
    # complain)
    - "echo 'nobody ALL=(ALL) NOPASSWD: /usr/bin/pacman' >> /etc/sudoers"
    # a writable home-directory is needed by import-validpgpkeys.sh
    # additionally the build directory must be owned by the user doing makepkg
    - mkdir -p ${WORK_DIR}
    - chown -R nobody /home/nobody
    - usermod -d /home/nobody nobody
  script:
    - cd ${WORK_DIR}
    - sudo -u nobody -E -H git clone "${AUR_SOURCE_REPO}" .
    - sudo -u nobody -E -H sed -f ${CI_PROJECT_DIR}/PKGBUILD.sed -i PKGBUILD
    - sudo -u nobody -E -H makepkg --syncdeps --noconfirm --cleanbuild
  artifacts:
    paths:
      - ${WORK_DIR}/*.pkg.tar.zst
